program DemoProject;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}
  cthreads,
  {$ENDIF}
  {$IFDEF HASAMIGA}
  athreads,
  {$ENDIF}
  Interfaces,// this includes the LCL widgetset
  sysutils,
  Forms, mainunit, splashunit, DataModulUnit, xwindowlist
  { you can add units after this };

{$R *.res}

var
  loEnde, loStart : DWord;
  XL: TXWindowList;
  i: integer;
  PID: cardinal;

begin
  XL := TXWindowList.Create;
  XL.UpdateWindowList;
  for i := 0 to XL.WindowList.Count - 1 do
  begin
    PID := XL.GetWindowPID(XL.WindowList[i]);
    if (PID <> 0) and (ExtractFileName(XL.GetWindowCmd(PID)) = ExtractFileName(Application.ExeName)) then
    begin
      XL.ActivateWindow(XL.WindowList[i]);
      Writeln('Window raised, exiting');
      Exit;
    end;
  end;
  XL.Free;

  RequireDerivedFormResource:=True;
  Application.Scaled:=True;
  Application.Initialize;

  loStart:=GetTickCount64;
  loStart:=loStart+100; // Zeit zum zeichen der SplashForm

  Application.CreateForm(TForm1, Form1);
  Application.CreateForm(TSplashForm, SplashForm);
  SplashForm.Show;  //----------------------------------------------------------------------------

  repeat                         //---------------------------------------------------------------
    loEnde:=GetTickCount64;      //------ Damit das Splash-Fenster vollständig sichtbar wird -----
    Application.ProcessMessages; //---------------------------------------------------------------
  until loEnde>loStart;          //---------------------------------------------------------------

  Application.CreateForm(TDataModule1, DataModule1);
  SplashForm.Close; //----------------------------------------------------------------------------

  Application.Run;
end.

